Welcome to Subscribe On Youtube

1176. Diet Plan Performance

Description

A dieter consumes calories[i] calories on the i-th day. 

Given an integer k, for every consecutive sequence of k days (calories[i], calories[i+1], ..., calories[i+k-1] for all 0 <= i <= n-k), they look at T, the total calories consumed during that sequence of k days (calories[i] + calories[i+1] + ... + calories[i+k-1]):

  • If T < lower, they performed poorly on their diet and lose 1 point; 
  • If T > upper, they performed well on their diet and gain 1 point;
  • Otherwise, they performed normally and there is no change in points.

Initially, the dieter has zero points. Return the total number of points the dieter has after dieting for calories.length days.

Note that the total points can be negative.

 

Example 1:

Input: calories = [1,2,3,4,5], k = 1, lower = 3, upper = 3
Output: 0
Explanation: Since k = 1, we consider each element of the array separately and compare it to lower and upper.
calories[0] and calories[1] are less than lower so 2 points are lost.
calories[3] and calories[4] are greater than upper so 2 points are gained.

Example 2:

Input: calories = [3,2], k = 2, lower = 0, upper = 1
Output: 1
Explanation: Since k = 2, we consider subarrays of length 2.
calories[0] + calories[1] > upper so 1 point is gained.

Example 3:

Input: calories = [6,5,0,0], k = 2, lower = 1, upper = 5
Output: 0
Explanation:
calories[0] + calories[1] > upper so 1 point is gained.
lower <= calories[1] + calories[2] <= upper so no change in points.
calories[2] + calories[3] < lower so 1 point is lost.

 

Constraints:

  • 1 <= k <= calories.length <= 10^5
  • 0 <= calories[i] <= 20000
  • 0 <= lower <= upper

Solutions

Solution 1: Prefix Sum

First, we preprocess a prefix sum array $s$ of length $n+1$, where $s[i]$ represents the total calories of the first $i$ days.

Then we traverse the prefix sum array $s$. For each position $i$, we calculate $s[i+k]-s[i]$, which is the total calories for the consecutive $k$ days starting from the $i$th day. According to the problem description, for each $s[i+k]-s[i]$, we judge its value with $lower$ and $upper$, and update the answer accordingly.

The time complexity is $O(n)$, and the space complexity is $O(n)$. Here, $n$ is the length of the calories array.

Solution 2: Sliding Window

We maintain a sliding window of length $k$, and the sum of the elements in the window is denoted as $s$. If $s \lt lower$, the score decreases by $1$; if $s > upper$, the score increases by $1$.

The time complexity is $O(n)$, where $n$ is the length of the calories array. The space complexity is $O(1)$.

  • class Solution {
        public int dietPlanPerformance(int[] calories, int k, int lower, int upper) {
            int n = calories.length;
            int[] s = new int[n + 1];
            for (int i = 0; i < n; ++i) {
                s[i + 1] = s[i] + calories[i];
            }
            int ans = 0;
            for (int i = 0; i < n - k + 1; ++i) {
                int t = s[i + k] - s[i];
                if (t < lower) {
                    --ans;
                } else if (t > upper) {
                    ++ans;
                }
            }
            return ans;
        }
    }
    
  • class Solution {
    public:
        int dietPlanPerformance(vector<int>& calories, int k, int lower, int upper) {
            int n = calories.size();
            int s[n + 1];
            s[0] = 0;
            for (int i = 0; i < n; ++i) {
                s[i + 1] = s[i] + calories[i];
            }
            int ans = 0;
            for (int i = 0; i < n - k + 1; ++i) {
                int t = s[i + k] - s[i];
                if (t < lower) {
                    --ans;
                } else if (t > upper) {
                    ++ans;
                }
            }
            return ans;
        }
    };
    
  • class Solution:
        def dietPlanPerformance(
            self, calories: List[int], k: int, lower: int, upper: int
        ) -> int:
            s = list(accumulate(calories, initial=0))
            ans, n = 0, len(calories)
            for i in range(n - k + 1):
                t = s[i + k] - s[i]
                if t < lower:
                    ans -= 1
                elif t > upper:
                    ans += 1
            return ans
    
    
  • func dietPlanPerformance(calories []int, k int, lower int, upper int) (ans int) {
    	n := len(calories)
    	s := make([]int, n+1)
    	for i, x := range calories {
    		s[i+1] = s[i] + x
    	}
    	for i := 0; i < n-k+1; i++ {
    		t := s[i+k] - s[i]
    		if t < lower {
    			ans--
    		} else if t > upper {
    			ans++
    		}
    	}
    	return
    }
    
  • function dietPlanPerformance(calories: number[], k: number, lower: number, upper: number): number {
        const n = calories.length;
        const s: number[] = new Array(n + 1).fill(0);
        for (let i = 0; i < n; ++i) {
            s[i + 1] = s[i] + calories[i];
        }
        let ans = 0;
        for (let i = 0; i < n - k + 1; ++i) {
            const t = s[i + k] - s[i];
            if (t < lower) {
                --ans;
            } else if (t > upper) {
                ++ans;
            }
        }
        return ans;
    }
    
    

All Problems

All Solutions